import { PropertyValues } from "lit";
import { FtLitElementRedux, FtRegistrationContext } from "@fluid-topics/ft-wc-utils";
import { FtReaderComponentInterface } from "./registration";
import { FtReaderStateManager } from "./store/FtReaderStateManager";
import { FtReaderPage, FtReaderScrollTarget, FtReaderTocNode } from "./store/model";
import type { FtMap, FtSession } from "@fluid-topics/public-api";
import { FtReaderContextProperties } from "./ft-reader-context.properties";
import type { FtReaderService } from "./store/utils/FtReaderService";
export declare class FtReaderContext extends FtLitElementRedux implements FtReaderContextProperties, FtRegistrationContext<FtReaderComponentInterface> {
    static styles: import("lit").CSSResult;
    baseUrl?: string;
    session?: FtSession;
    mapId?: string;
    tocId?: string;
    section?: string;
    topicPivot?: string;
    searchInDocumentQuery?: string;
    page?: number;
    map?: FtMap;
    toc?: FtReaderTocNode[];
    visibleTopics: string[];
    currentPage?: FtReaderPage;
    scrollTarget?: FtReaderScrollTarget;
    readerServiceProvider?: () => Promise<FtReaderService>;
    constructor();
    protected render(): import("lit").TemplateResult<1>;
    private importStyleIfNeeded;
    private _stateManager?;
    get stateManager(): FtReaderStateManager;
    connectedCallback(): void;
    protected update(props: PropertyValues): void;
    private scrollToTargetDebouncer;
    protected contentAvailableCallback(props: PropertyValues): void;
    clear(): void;
    reload(): Promise<void>;
    private navigationDebouncer;
    private lastNotifiedNotFoundRelative;
    navigateToTarget(): Promise<void>;
    private registerComponent;
    register(component: FtReaderComponentInterface): void;
    private handleLoadError;
    reloadBookmarks(): void;
    reloadRating(): Promise<void>;
    private mapLoadedEventDebouncer;
    sendLoadedEventIfLoaded(): void;
}
