import { FtMap } from "@fluid-topics/public-api";
import { FtReaderNavigationData, FtReaderTocNode } from "./store/model";
export type MapLoadedEventDetail = {
    map: FtMap;
    toc: Array<FtReaderTocNode>;
};
export declare class MapLoadedEvent extends CustomEvent<MapLoadedEventDetail> {
    constructor(map: FtMap, toc: Array<FtReaderTocNode>);
}
export interface FtReaderBreadcrumb {
    tocId: string;
    title: string;
}
export interface FtReaderVisibleTopic {
    tocId: string;
    title: string;
    page?: number;
    prettyUrl?: string;
    prettyUrlDuplicated: boolean;
    breadcrumb?: Array<FtReaderBreadcrumb>;
}
export interface VisibleTopicsChangeData {
    visibleTopics: FtReaderVisibleTopic[];
}
export declare class VisibleTopicsChangeEvent extends CustomEvent<VisibleTopicsChangeData> {
    constructor(map: FtMap, visibleTopics: FtReaderVisibleTopic[]);
}
export declare class NavigationDoneEvent extends CustomEvent<FtReaderNavigationData> {
    constructor(data: FtReaderNavigationData);
}
export declare class LoadErrorEvent extends CustomEvent<Error> {
    constructor(e: Error);
}
export declare class NotFoundErrorEvent extends Event {
    constructor();
}
export declare class UnauthorizedErrorEvent extends Event {
    constructor();
}
export declare class ForbiddenErrorEvent extends Event {
    constructor();
}
export declare class TopicRelativeNotFoundEvent extends Event {
    constructor();
}
