export class MapLoadedEvent extends CustomEvent {
    constructor(map, toc) {
        super("ft-reader-map-loaded", { detail: { map, toc } });
    }
}
export class VisibleTopicsChangeEvent extends CustomEvent {
    constructor(map, visibleTopics) {
        super("ft-reader-visible-topics-change", { detail: { visibleTopics } });
    }
}
export class NavigationDoneEvent extends CustomEvent {
    constructor(data) {
        super("ft-reader-navigation-done", { detail: data });
    }
}
export class LoadErrorEvent extends CustomEvent {
    constructor(e) {
        super("ft-reader-load-error", { detail: e });
    }
}
export class NotFoundErrorEvent extends Event {
    constructor() {
        super("ft-reader-map-not-found");
    }
}
export class UnauthorizedErrorEvent extends Event {
    constructor() {
        super("ft-reader-map-unauthorized");
    }
}
export class ForbiddenErrorEvent extends Event {
    constructor() {
        super("ft-reader-map-forbidden");
    }
}
export class TopicRelativeNotFoundEvent extends Event {
    constructor() {
        super("ft-reader-topic-relative-not-found", { bubbles: true, composed: true });
    }
}
