var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { FtLitElementRedux } from "@fluid-topics/ft-wc-utils";
import { state } from "lit/decorators.js";
export * from "./store/model";
export class RegisterReaderComponentEvent extends Event {
    constructor() {
        super("register-ft-reader-component", { bubbles: true, composed: true });
    }
}
const registerInterval = Symbol("registerInterval");
export function toFtReaderComponent(ReduxClass) {
    var _a;
    class FtReaderComponentClass extends ReduxClass {
        constructor() {
            super(...arguments);
            this[_a] = 0;
        }
        setReaderStateManager(stateManager) {
            this.clearStateManager();
            this.stateManager = stateManager;
            this.addStore(stateManager.store, "reader");
        }
        clearStateManager() {
            if (this.stateManager) {
                this.removeStore("reader");
                this.stateManager = undefined;
            }
        }
        get service() {
            var _b;
            return (_b = this.stateManager) === null || _b === void 0 ? void 0 : _b.service;
        }
        connectedCallback() {
            super.connectedCallback();
            this[registerInterval] = window.setInterval(() => this.tryToRegisterToContext(), 50);
        }
        tryToRegisterToContext() {
            if (this.stateManager != null) {
                window.clearInterval(this[registerInterval]);
            }
            else {
                this.dispatchEvent(new RegisterReaderComponentEvent());
            }
        }
        disconnectedCallback() {
            super.disconnectedCallback();
            this.clearStateManager();
        }
    }
    _a = registerInterval;
    __decorate([
        state()
    ], FtReaderComponentClass.prototype, "stateManager", void 0);
    return FtReaderComponentClass;
}
export class FtReaderComponent extends toFtReaderComponent(FtLitElementRedux) {
}
