import { ClusteringHelper } from "@fluid-topics/ft-wc-utils";
import { FtReaderReduxStore } from "./redux";
import type { FtReaderService } from "./utils/FtReaderService";
export declare class FtReaderStateManager {
    store: FtReaderReduxStore;
    private clusteringHelperProvider?;
    static build(id: string, serviceProvider?: () => Promise<FtReaderService>): FtReaderStateManager;
    metadataForSwitchToRelatives: Set<string>;
    clusteringHelper?: ClusteringHelper;
    service?: FtReaderService;
    errorHandler?: (e: Error) => void;
    private _loaded;
    loaded(): Promise<void>;
    constructor(store: FtReaderReduxStore, serviceProvider: () => Promise<FtReaderService>, clusteringHelperProvider?: (() => ClusteringHelper) | undefined);
    initService(serviceProvider: () => Promise<FtReaderService>): Promise<void>;
    setMapId(mapId?: string): Promise<void>;
    setRenderedTopics(tocIds: string[]): void;
    setVisibleTopics(tocIds: string[]): void;
    awaitService(): Promise<FtReaderService>;
    navigateToTopic(tocId?: string, section?: string, pageNumber?: number): Promise<void>;
    private resolveValidNonRootTocId;
    navigateToPage(pageNumber: number): Promise<void>;
    scrollDone(): void;
    private loadDebouncer;
    load(): Promise<void>;
    clear(): void;
    reload(): Promise<void>;
    private fetchData;
    private fetchRelatives;
    private updateClusteringHelper;
    private createClusteringHelper;
    navigateToRelativeTopicIfFound(topicPivotMetadataValue: string): Promise<boolean>;
    setSearchInDocumentQuery(query: string): void;
    registerMetadataForSwitchToRelatives(id: string): void;
    unregisterMetadataForSwitchToRelatives(id: string): void;
}
