import { FtMap, FtPaginationConfiguration, FtRatingType, FtRatingTypeKeys, FtReaderConfiguration, FtSearchResultClusterEntry, FtSession, FtTocNode, FtTopic, FtTopicRating } from "@fluid-topics/public-api";
import { Optional } from "@fluid-topics/ft-wc-utils";
export interface FtPagesTocNode {
    depth: number;
    tocId: string;
    title: string;
    children: Array<FtPagesTocNode>;
}
export interface FtReaderTocNode extends FtTocNode {
    depth: number;
    parentTocId?: string;
    children: Array<FtReaderTocNode>;
}
export interface FtReaderPage {
    number: number;
    title: string;
    rootTocId: string;
    toc: Array<FtReaderTocNode>;
    topics: Array<string>;
    hiddenTopics: Array<string>;
    breadcrumb: string[];
}
export interface FtReaderTopic extends FtTopic {
    htmlContent?: string;
}
export type FtReaderScrollTarget = {
    tocId?: string;
    section?: string;
};
export interface FtReaderState {
    mapId: string | undefined;
    map: Optional<FtMap>;
    toc: Optional<Array<FtReaderTocNode>>;
    pagesToc: Optional<Array<FtPagesTocNode>>;
    paginationConfiguration: Optional<FtPaginationConfiguration>;
    currentPage: Optional<FtReaderPage>;
    scrollTarget: Optional<FtReaderScrollTarget>;
    renderedTopics: string[];
    visibleTopics: string[];
    configuration: Optional<FtReaderConfiguration>;
    searchInDocumentQuery: Optional<string>;
    relatives: Optional<Array<FtSearchResultClusterEntry>>;
}
export interface FtReaderNavigationData {
    mapId: string;
    tocId: string;
    topicTitle: string;
    section?: string;
    page?: number;
    prettyUrl?: string;
    prettyUrlDuplicated: boolean;
}
export interface FtTopicRatingSummary {
    rating?: FtTopicRating;
    type: FtRatingType | FtRatingTypeKeys;
}
export declare enum FtReaderFeatures {
    FEEDBACK = "FEEDBACK",
    RATING = "RATING",
    PRINT = "PRINT",
    BOOKMARK = "BOOKMARK",
    COLLECTIONS = "COLLECTIONS",
    PERSONAL_BOOKS = "PERSONAL_BOOKS"
}
export interface FtReaderFeatureAccessData {
    session?: FtSession;
}
