import type { FtMap, FtMapAttachment, FtPaginatedToc, FtRatingSummary, FtRatingType, FtRatingTypeKeys, FtSearchResults, FtTocNode, FtTopic } from "@fluid-topics/public-api";
import { FtReaderService } from "./FtReaderService";
import { FtReaderFeatures } from "../model";
export declare class FtOfficialReaderService extends FtReaderService {
    protected fingerprint?: string;
    static build(mapId?: string): Promise<FtOfficialReaderService>;
    clear(): void;
    protected fetchMap(mapId: string): Promise<FtMap>;
    protected fetchMapRating(mapId: string): Promise<FtRatingSummary>;
    protected fetchPages(mapId: string): Promise<FtPaginatedToc>;
    protected fetchTopicHTMLContent(tocNode: FtTocNode): Promise<string>;
    protected fetchTopicMetadata(tocNode: FtTocNode): Promise<FtTopic>;
    protected fetchAttachments(): Promise<Array<FtMapAttachment>>;
    protected fetchRelativesForDocument(metadataPivotKey: string, metadataPivotValues: string[]): Promise<FtSearchResults>;
    protected fetchRelativesForTopicInMap(mapId: string, metadataPivotKey: string, metadataPivotValues: string[]): Promise<FtSearchResults>;
    protected makeMapFeedbackRequest(message: string, from?: string): Promise<void>;
    protected makeRateMapRequest(type: FtRatingType | FtRatingTypeKeys, value: number): Promise<void>;
    protected makeRateTopicRequest(tocId: string, type: FtRatingType | FtRatingTypeKeys, value: number): Promise<void>;
    protected makeTopicFeedbackRequest(tocId: string, message: string, from?: string): Promise<void>;
    protected makeUnrateMapRequest(): Promise<void>;
    protected makeUnrateTopicRequest(tocId: string): Promise<void>;
    protected getReaderLinkPrefix(): string;
    isFeatureAvailable(feature: FtReaderFeatures): boolean;
}
